#include "StdAfx.h"
#include "HttpFileDownload.h"

CHttpFileDownload::CHttpFileDownload(CString strURL, CString strLocalDir, CString strFileName)
: m_strFileURL(strURL)
, m_strLocalDir(strLocalDir)
, m_strFileName(strFileName)
{
}

CHttpFileDownload::~CHttpFileDownload(void)
{
}

int CHttpFileDownload::DownloadFile(void)
{
	int result = 0;

	HINTERNET m_hInternet = NULL;
	HINTERNET m_hURL = NULL;
	HANDLE hDownLoadFile;
	hDownLoadFile = INVALID_HANDLE_VALUE;

	DWORD dwSize, dwRead, dwWritten, dwTotalWrittenBytes;
    BYTE baBuffer[ 1024 * 10 ] = {0};
	int nStatusCode;
	CString strDbg;
	WIN32_FIND_DATA findData;
	HANDLE hFind = INVALID_HANDLE_VALUE;
	//int idx = 0;

	CString strFindFile = m_strFileName;
	CString strFindPath;

	if(m_strFileURL.IsEmpty())
	{
		result = ERROR_INVALID_PARAMETER;		
		goto finish;
	}

	m_hInternet = InternetOpen(_T("NTalkbiz"), INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
	if( m_hInternet == NULL )
	{
		result = GetLastError();
		OutputDebugString(_T("InternetOpen()"));
		goto finish;
	}

	m_hURL = InternetOpenUrlW(m_hInternet, m_strFileURL, NULL, 0,  INTERNET_FLAG_RELOAD | INTERNET_FLAG_NO_CACHE_WRITE , 0);
	if(m_hURL == NULL)
	{
		result = GetLastError();
		OutputDebugString(_T( "InternetOpenUrl()"));
		goto finish;
	}

	dwSize = sizeof(baBuffer);
	result = HttpQueryInfo(m_hURL, HTTP_QUERY_STATUS_CODE, baBuffer, &dwSize, NULL);
	if( result == FALSE )
	{
		result = GetLastError();
		OutputDebugString(_T( "HttpQueryInfo()"));
		goto finish;
	}

	nStatusCode = _ttoi((LPCTSTR)baBuffer);
	if( nStatusCode == 404 )
	{
		result = ERROR_NOT_FOUND;		
		goto finish;
	}
	else if((nStatusCode != 200) && (nStatusCode != 304))
	{

		result = GetLastError();		
		goto finish;
	}



	memset(&findData, 0x00, sizeof(WIN32_FIND_DATA));

	strFindPath.Format(_T("%s\\%s"), m_strLocalDir, strFindFile);
	hFind = FindFirstFile(strFindPath, &findData);
	if(hFind != INVALID_HANDLE_VALUE)
	{
		result = ERROR_ALREADY_REGISTERED;
		goto finish;
	}

	hDownLoadFile = CreateFile(strFindPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if( hDownLoadFile == INVALID_HANDLE_VALUE )
	{		
		CreateDirectoryTree(m_strLocalDir);
		hDownLoadFile = CreateFile(strFindPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hDownLoadFile == INVALID_HANDLE_VALUE )
		{
			result = GetLastError();			
			goto finish;
		}
	}

	dwTotalWrittenBytes = 0;

	int nLoopCnt = 0;
	do
	{
		result = InternetQueryDataAvailable(m_hURL, &dwSize, 0, 0);
		if( result == FALSE )
		{
			result = GetLastError();
			OutputDebugString(_T( "InternetQueryDataAvailable()"));
			goto finish;
		}

		//
		// ۰ Ѿ  ؼ...
		//
		if( dwSize > sizeof(baBuffer) )
		{
			dwSize = sizeof(baBuffer);
		}

		result = InternetReadFile(m_hURL, baBuffer, dwSize, &dwRead);
		if(result == FALSE)
		{
			result = GetLastError();
			strDbg.Format(_T("InternetReadFile()"));
			OutputDebugString(strDbg);
			goto finish;
		}

		result = WriteFile(hDownLoadFile, baBuffer, dwRead, &dwWritten, NULL);
		if(result == FALSE)
		{
			result = GetLastError();
			strDbg.Format(_T("WriteFile()"));
			OutputDebugString(strDbg);
			goto finish;
		}

		dwTotalWrittenBytes += dwWritten;

		nLoopCnt++;
	} while(dwRead != 0);

	result = 0;

finish:
	if(result != 0)
	{
		OutputDebugString(_T( "CHttpFileDownload::DownloadFile()"));
	}

	if( m_hURL != NULL )
	{
		InternetCloseHandle( m_hURL );
	}

	if( m_hInternet != NULL )
	{
		InternetCloseHandle( m_hInternet );
	}

	if( hDownLoadFile != INVALID_HANDLE_VALUE )
	{
		CloseHandle( hDownLoadFile );
	}

	return result;
}
